%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
assert_isequal(nargin('whosnh5'), 1);
assert_isequal(nargout('whosnh5'), 1);
%=============================================================================
D = sparse(3i);
savenh5([tempdir(), 'test_whosnh5_1.nh5'],  'D');
%=============================================================================
S = whosnh5([tempdir(), 'test_whosnh5_1.nh5']);
assert_isequal(S.name, 'D');
assert_isequal(S.size, [1 1]);
assert_isequal(S.bytes, NaN);
assert_isequal(S.class, 'sparsedouble');
assert_isequal(S.global, false);
assert_isequal(S.sparse, true);
assert_isequal(S.complex, true);
assert_isequal(S.nesting, struct('function', '', 'level', 0));
assert_isequal(S.persistent, false);
%=============================================================================
A = ones(3, 4);
B = 'Nelson';
C = sparse(true);
D = sparse(3i);
savenh5([tempdir(), 'test_whosnh5.nh5'], 'A', 'B', 'C', 'D');
whosnh5([tempdir(), 'test_whosnh5.nh5'])
%=============================================================================
