%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
function txt = nig_variable_double_array(VARIABLE, withLocal)
  txt = '';
  if strcmp(VARIABLE.MODE, 'input')
    txt = [txt, 'const double *', toupper(VARIABLE.NAME)];
  end
  if strcmp(VARIABLE.MODE, 'output')
    txt = [txt, ' double *', toupper(VARIABLE.NAME)];
  end
  if strcmp(VARIABLE.MODE, 'in_out')
    txt = [txt, ' double *', toupper(VARIABLE.NAME)];
  end
  if withLocal
    if strcmp(VARIABLE.MODE, 'local')
      txt = [txt, ' double *', toupper(VARIABLE.NAME)];
    end
  end
end
%=============================================================================
