%=============================================================================
% Copyright (c) 2017 Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
% <-- Issue URL -->
% https://github.com/Nelson-numerical-software/nelson/issues/284
% <-- Short Description -->
% Nth dimensions assignation of an empty array with 2d matrix did not work
%=============================================================================
clear('A');
A(:, :, 1) = [2 4; -2 1];
A(:, :, 2) = [9 13; -5 7];
A(:, :, 3) = [4 4; 8 -3];
assert_istrue(isvar('A'));
assert_isequal(size(A), [2 2 3]);
REF1 = [2 4; -2 1];
REF2 = [9 13; -5 7];
REF3 = [4 4; 8 -3];
assert_isequal(A(:, :, 1), REF1);
assert_isequal(A(:, :, 2), REF2);
assert_isequal(A(:, :, 3), REF3);
%=============================================================================
