%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
o = weboptions('RequestMethod', 'get');
filename = [tempdir(), 'test_websave_args.json'];
fullname = websave(filename, 'http://httpbin.org/get', 'r', i, "b+", 3, o);
R = jsondecode(fileread(fullname));
assert_istrue(isstruct(R.args));
assert_isequal(fieldnames(R.args), {'b_'; 'r'});
assert_isequal(R.args.b_, '3');
assert_isequal(R.args.r, '0+1i');
%=============================================================================
o = weboptions('RequestMethod', 'get', 'ArrayFormat', 'csv');
filename = [tempdir(), 'test_websave_args.json'];
M = [1 2 3; 4 5 6];
fullname = websave(filename, 'http://httpbin.org/get', 'r', M, o);
R = jsondecode(fileread(fullname))
%=============================================================================
o = weboptions('RequestMethod', 'get', 'ArrayFormat', 'json');
filename = [tempdir(), 'test_websave_args.json'];
M = [1 2 3; 4 5 6];
fullname = websave(filename, 'http://httpbin.org/get', 'r', M, o);
R = jsondecode(fileread(fullname))
%=============================================================================
o = weboptions('RequestMethod', 'get', 'ArrayFormat', 'repeating');
filename = [tempdir(), 'test_websave_args.json'];
M = [1 2 3; 4 5 6];
fullname = websave(filename, 'http://httpbin.org/get', 'r', M, o);
R = jsondecode(fileread(fullname))
%=============================================================================
o = weboptions('RequestMethod', 'get', 'ArrayFormat', 'php');
filename = [tempdir(), 'test_websave_args.json'];
M = [1 2 3; 4 5 6];
fullname = websave(filename, 'http://httpbin.org/get', 'r', M, o);
R = jsondecode(fileread(fullname))
%=============================================================================
